use keygen::Person;
use discrete_logarithm::discrete_log_pollard_rho;
use rug::Integer;

mod keygen;
mod utils;

fn main() {
    let mut alice = Person::new("alice");
    let mut bob = Person::new("bob");
    Person::diffie_hellman(&mut alice, &mut bob);
    alice.send(b"Hello World", &bob);

    let n_primediv = discrete_log_pollard_rho(&Integer::from(alice.r#mod.unwrap())
    , &Integer::from(alice.public_key.unwrap()), &Integer::from(alice.gen.unwrap()), None);
    eprintln!(
        "[{}] Calculated private key {} from public key {}",
        alice.name,
        n_primediv.unwrap(),
        alice.public_key.unwrap()
    );
}
